DECLARE SUB waitin (timey!)
'COPYRIGHT 1994 by Brian Deitte
DECLARE SUB Trim (a$, AutoNumb%, part() AS STRING, count%)
DECLARE SUB subTime (timey$)
DECLARE SUB subAddNumb (b%, file$)
start! = TIMER
DEFINT A-Z
SCREEN 0
WIDTH 80, 25
RANDOMIZE TIMER

TYPE FileDat
  FileName AS STRING * 50
  LengthOfFile AS LONG
  NumberOfQuotes AS INTEGER
END TYPE
DIM SayDat AS FileDat

DIM party(1 TO 500) AS STRING, Delim(1 TO 200) AS STRING, header(1 TO 200) AS STRING, Lines$(1 TO 1000), Freq(1 TO 200), CentVert(200), CentHor(200), DelimFirst(200)
DIM SHARED file(1 TO 200) AS STRING

CONST TRUE = -1, FALSE = NOT TRUE, USED = 8

filenumb = 0
coma$ = COMMAND$
coma$ = LTRIM$(RTRIM$(coma$))
'coma$ = LTRIM$(RTRIM$(RIGHT$(coma$, LEN(coma$) - INSTR(coma$, " "))))
IF INSTR(coma$, ":") <> 0 THEN
  placey = INSTR(coma$, ":")
  placey2 = INSTR(coma$, " ")
  IF placey2 <> 0 THEN
    IF placey2 < placey THEN
      CFile = VAL(MID$(coma$, placey2, placey - placey2 + 1))
      Cnumb = VAL(RIGHT$(coma$, LEN(coma$) - INSTR(coma$, ":")))
    ELSE
      CFile = VAL(LEFT$(coma$, placey - 1))
      Cnumb = VAL(MID$(coma$, placey + 1, placey2 - placey + 1))
    END IF
  ELSE
    CFile = VAL(LEFT$(coma$, placey - 1))
    Cnumb = VAL(RIGHT$(coma$, LEN(coma$) - INSTR(coma$, ":")))
  END IF
END IF
IF coma$ = "/?" OR coma$ = "?" OR coma$ = "h" OR coma$ = "-h" THEN
  PRINT ""
  PRINT "The command line options are"
  PRINT
  PRINT "say ?:?"
  PRINT "where the first ? is the file to choose"
  PRINT "(number is determined by the order in the"
  PRINT "'sayings.ini' file), and the second ? is the"
  PRINT "quote to show from that file."
  PRINT "To show a random quote from just one file,"
  PRINT "put 0 as the second ?."
  PRINT
  PRINT "say wow"
  PRINT "This will show the quote in an interesting"
  PRINT "way.  It does not work with quotes that"
  PRINT "are longer than 23 lines."
  PRINT ""
  PRINT "To configure other aspects of this program,"
  PRINT "please edit the 'sayings.ini' file."
  PRINT "If you are unfamiliar with sayings.ini,"
  PRINT "please read 'sayings.doc'."
  END
END IF



'**************************************************************************

'The following part opens the sayings.ini file, reads parts of it,
'and configures parts of the program accordanly

TheINIConfig:


DeLoc$ = ENVIRON$("SAYINGS") + "\"
IF DeLoc$ = "\" THEN DeLoc$ = ""
'open ini file
ON ERROR GOTO NoIniFile
OPEN DeLoc$ + "sayings.ini" FOR INPUT AS #1
ON ERROR GOTO 0
'''ON ERROR GOTO DontKnow


LINE INPUT #1, a$
IF a$ = ";SAYINGS by Brian Deitte" THEN  'just checking if someone messed with the file
  LINE INPUT #1, a$
  a$ = LCASE$(a$)
  IF a$ = ";see sayings.doc for more information on editing this file" THEN
    LINE INPUT #1, a$               'get past extra line in the ini file
  ELSE
    GOTO AlteredINI
  END IF
ELSE
  GOTO AlteredINI                 'ini has been altered wrongly
END IF


DO UNTIL EOF(1)

  LINE INPUT #1, IniLine$
 
  IF RTRIM$(IniLine$) = "" THEN GOTO Ender
  IF LEFT$(LTRIM$(IniLine$), 1) = ";" THEN GOTO Ender
 
  b% = INSTR(IniLine$, "=")          'find out where the = sign is

  IF b% = 0 THEN
    CLS
    PRINT "The line "; IniLine$; " should not be there."
    PRINT "There's just no need for it!"
    SLEEP 5
    GOTO Ender
  END IF
    
  TotalNum% = LEN(IniLine$)             'find total number of characters
  IniLineL$ = LEFT$(IniLine$, (b% - 1)) 'get the characters to the left of =
  LeftNum% = LEN(IniLineL$)             'find the total on left of = sign
  RightNum% = TotalNum% - LeftNum% - 1  'figure out the right side's sum
  a$ = MID$(IniLine$, b% + 1, RightNum%)'copy characters on right side of =

  IniLineL$ = LCASE$(RTRIM$(LTRIM$(IniLineL$)))
  a$ = LCASE$(RTRIM$(LTRIM$(a$)))

  Yes = FALSE
  No = FALSE
  IF LEFT$(a$, 1) = "y" THEN Yes = TRUE
  IF LEFT$(a$, 1) = "n" THEN No = TRUE

SELECT CASE IniLineL$

  CASE "file location"
    filenumb = filenumb + 1
    file(filenumb) = a$
    IF NoHeader = TRUE THEN header(filenumb) = ""
    IF NoDelim = TRUE THEN Delim(filenumb) = "NewL2"
    IF NoFreq = TRUE THEN
      IF filenumb <> 1 THEN
        Freq(filenumb) = Freq(filenumb - 1) + 2
      ELSE
        Freq(filenumb) = 2
      END IF
    END IF
    NoHeader = TRUE
    NoDelim = TRUE
    NoFreq = TRUE
    GOTO Ender

  CASE "header"
    IF NoHeader = TRUE THEN
      header(filenumb) = MID$(IniLine$, INSTR(IniLine$, "=") + 1, RightNum%)
      NoHeader = FALSE
    ELSE
      header(filenumb) = header(filenumb) + CHR$(13) + MID$(IniLine$, INSTR(IniLine$, "=") + 1, RightNum%)
    END IF
  GOTO Ender
 
  CASE "new quote deliminator"
    'what character to use to indicate a new quote
    IF NoDelim = TRUE THEN
      SELECT CASE LEFT$(a$, 10)
      CASE "blank line"
        Delim(filenumb) = "NewL2"
        IF LEN(a$) > 10 THEN
          NewL2Numb = VAL(MID$(a$, 12, 1))
          END IF
      CASE "return"
        Delim(filenumb) = "NewL"
      CASE "new line"
        Delim(filenumb) = "NewL"
      CASE "enter"
        Delim(filenumb) = "NewL"
      CASE "tab"
        Delim(filenumb) = STRING$(1, 15)
      END SELECT
      IF VAL(a$) <> 0 THEN
        Delim(filenumb) = "NewLM"
        NewLMNumb = VAL(a$)
        IF MID$(a$, LEN(NewLMNumb), 1) = "c" THEN NewLMCon = TRUE
      END IF
      IF Delim(filenumb) = "" THEN Delim(filenumb) = LEFT$(a$, 1)
      IF Delim(filenumb) = "" THEN Delim(filenumb) = "NewL2"
      NoDelim = FALSE
    END IF
    GOTO Ender

  CASE "freq"
    IF NoFreq = TRUE THEN
      IF VAL(a$) > 0 THEN
        IF filenumb <> 1 THEN
          Freq(filenumb) = Freq(filenumb - 1) + VAL(a$)
        ELSE
          Freq(filenumb) = VAL(a$)
        END IF
      ELSE
        IF filenumb <> 1 THEN
          Freq(filenumb) = Freq(filenumb - 1) + 2
        ELSE
          Freq(filenumb) = 2
        END IF
      END IF
      Freq = FALSE
    END IF
    GOTO Ender

  CASE "print heading"
    'checks if wants a heading
    IF Yes = TRUE THEN Heading = TRUE
    GOTO Ender
  
  CASE "center vertically"
    'checks if wants to center vertically
    IF Yes = TRUE THEN CenterVert = TRUE
    GOTO Ender
 
  CASE "center horizontally"
    'checks if wants to center horizontally
    IF Yes = TRUE THEN CenterHor = TRUE
    GOTO Ender

  CASE "center this vertically"
  IF CentVert(filenumb) = 0 THEN
    IF Yes = TRUE THEN
      CentVert(filenumb) = TRUE
    ELSE
      CentVert(filenumb) = USED
    END IF
  END IF
  GOTO Ender

  CASE "center this horizontally"
  IF CentHor(filenumb) = 0 THEN
    IF Yes = TRUE THEN
      CentHor(filenumb) = TRUE
    ELSE
      CentHor(filenumb) = USED
    END IF
  END IF
  GOTO Ender

  CASE "auto-wrap"
    IF Yes = TRUE THEN autowrap = TRUE
    GOTO Ender

  CASE "auto-wrap at"
    IF VAL(a$) <> 0 THEN
      AutoNumb = VAL(a$)
    ELSE
      AutoNumb = 79
    END IF
    GOTO Ender
 
  CASE "clear the screen before showing the quote"
    'checks if wants to clear the screen before displaying the quote
    IF Yes = TRUE THEN ClsBefore = TRUE
    GOTO Ender


  CASE "clear the screen after showing the quote"
    'checks if wants to clear the screen after displaying the quote
    IF Yes = TRUE THEN ClsAfter = TRUE
    GOTO Ender

  CASE "delay while displaying"
    IF No = TRUE THEN DontSleep = TRUE
    GOTO Ender

  CASE "time to display (seconds per line)"
    'checks how long it wants to display the quote
    '(each second = 1 second per line shown)
    sleepy = VAL(a$)
    IF sleepy < 0 THEN sleepy = 0
    GOTO Ender

  CASE "show the file and number of quote shown"
    IF Yes = TRUE THEN numbers = TRUE
  GOTO Ender
 
  CASE "show the time"
    IF Yes = TRUE THEN ShowTime = TRUE
    GOTO Ender

  CASE "show time used"
    IF Yes = TRUE THEN TimeUsed = TRUE
    GOTO Ender

  CASE "hot key to put shown quote in another file"
    'checks if wants hot key to put shown quote in another file
    IF Yes = FALSE THEN QSaveBegin = TRUE
    GOTO Ender

  CASE "file to put the quote in"
    'where to put quote after pressing hot key
    HKeyFile$ = a$
    GOTO Ender
 
  CASE "hot key"
    'finds what the hot key should be
    IF LEN(a$) = 1 THEN
      HotKey = ASC(a$)
      GOTO Ender
    END IF
    IF LEFT$(a$, 5) = "ascii" THEN
      SELECT CASE LEN(a$)
        CASE 6
          a$ = MID$(a$, 6, 1)
        CASE 7
          a$ = MID$(a$, 7, 1)
        CASE 8
          a$ = MID$(a$, 7, 2)
        CASE IS >= 9
          a$ = MID$(a$, 7, 3)
      END SELECT
        HotKey = VAL(a$)
        IF HotKey < 0 OR HotKey > 255 THEN HotKey = 42      'default of *
    ELSE
      SELECT CASE a$
        CASE "space bar"
          HotKey = 32
        CASE "enter"
          HotKey = 13
        CASE "return"
          HotKey = 13
        CASE "backspace"
          HotKey = 8
        CASE "escape"
          HotKey = 27
        CASE "insert"
          HotKey = 82
        CASE "print screen"
          HotKey = 42
        CASE "tab"
          HotKey = 9
      END SELECT
    END IF
    IF HotKey = 0 THEN HotKey = 32                 'default of spacebar
    GOTO Ender
    
  CASE "rate"
    rate$ = a$
  GOTO Ender

END SELECT

Ender:

LOOP
CLOSE

'**************************************************************************

Main:

'open random text file
ToFile = filenumb

IF CFile > 0 AND CFile <= filenumb THEN  'if use command-line
  filenumb = CFile                                                'override
  CGet = TRUE
  GOSUB CountEm
  IF Cnumb <= b% AND Cnumb > 0 THEN
    rndnumb = Cnumb
    filenumb = CFile
    GOTO FindQuote
  ELSE
    CGet = FALSE
    CLOSE
    GOTO CountEm
  END IF
END IF

IF rate$ = "off" THEN filenumb = INT((filenumb) * RND + 1)

IF rate$ = "total" THEN
    RateAll = TRUE
    FOR o = 1 TO filenumb
      GOSUB CountEm
      CLOSE
      IF o <> 1 THEN
        Freq(o) = Freq(o - 1) + b%
      ELSE
        Freq(o) = b%
      END IF
    NEXT o
    RateAll = FALSE
END IF

IF rate$ <> "off" THEN
   numbtemp = INT((Freq(filenumb)) * RND + 1)
   FOR o = 1 TO filenumb
     IF numbtemp <= Freq(o) THEN
       filenumb = o
       EXIT FOR
     END IF
   NEXT o
END IF

CountEm:
file$ = file(filenumb)
OPEN file$ FOR INPUT AS #1
b% = 0
'Find out how many quotes by counting the deliminators
DeLoc$ = ENVIRON$("SAYINGS") + "\"
IF DeLoc$ = "\" THEN DeLoc$ = ""
OPEN DeLoc$ + "sayings.dat" FOR RANDOM AS #2
i = 0
  DO UNTIL EOF(2)
    i = i + 1
    GET #2, i, SayDat
    IF LTRIM$(RTRIM$(LCASE$(SayDat.FileName$))) = LTRIM$(RTRIM$(LCASE$(file$))) THEN
      FileThere = TRUE
      IF SayDat.LengthOfFile = LOF(1) THEN
        b% = SayDat.NumberOfQuotes
        GOTO NextPart
        EXIT DO
      ELSE
        NoNum = TRUE
        EXIT DO
      END IF
    END IF
  LOOP
  IF FileThere = FALSE THEN
    FOR b = 1 TO i
      GET #2, b, SayDat
      FOR x = 1 TO ToFile
        IF SayDat.FileName = file(x) THEN There = TRUE: EXIT FOR
      NEXT x
      IF There = TRUE THEN i = i + 1: EXIT FOR
    NEXT b
    i = b - 1
    SayDat.FileName = LTRIM$(RTRIM$(LCASE$(file$)))
    SayDat.LengthOfFile = LOF(1)
    NoNum = TRUE
  END IF

ExitIf:
b% = 1

SELECT CASE Delim(filenumb)
 
  CASE "NewL2"
    DO UNTIL EOF(1)
      LINE INPUT #1, a$
      IF LTRIM$(RTRIM$(a$)) = "" THEN b% = b% + 1
    LOOP

  CASE "NewL"
    b% = 0
    DO UNTIL EOF(1)
      LINE INPUT #1, a$
      b% = b% + 1
    LOOP
 
  CASE "NewLM"
    StillBlank = TRUE
    counter = 0
    IF NewLMCon = TRUE THEN
      DO UNTIL EOF(1)
        LINE INPUT #1, a$
        IF LTRIM$(RTRIM$(a$)) = "" THEN
          IF StillBlank = TRUE THEN
            counter = counter + 1
            IF counter = NewLMNumb THEN
              counter = 0
              b% = b% + 1
            END IF
          ELSE
            counter = counter + 1
            StillBlank = TRUE
          END IF
        ELSE
          StillBlank = FALSE
          counter = 0
        END IF
      LOOP
    ELSE
      DO UNTIL EOF(1)
        LINE INPUT #1, a$
        IF LTRIM$(RTRIM$(a$)) = "" THEN
          counter = counter + 1
          IF counter = NewLMNumb THEN
            counter = 0
            b% = b% + 1
          END IF
        END IF
      LOOP
   END IF

  CASE ELSE
    LenDelim = LEN(Delim(filenumb))
    DO UNTIL EOF(1)
      a$ = INPUT$(1, #1)
      IF a$ = Delim(filenumb) THEN b% = b% + 1
    LOOP
  END SELECT


IF NoNum = TRUE THEN
  SayDat.NumberOfQuotes = b%
  PUT #2, i, SayDat
END IF
CLOSE 2

Nope:

NextPart:
IF CGet = TRUE THEN RETURN
IF RateAll = TRUE THEN RETURN
'Get random number that is within the range of quotes
rndnumb = INT((b%) * RND) + 1

''PRINT b%
''PRINT rndnumb

FindQuote:
'set things back to normal
b% = 0
SEEK #1, 1


'Find the random quote
QNumb = 1


SELECT CASE Delim(filenumb)

 CASE "NewL2"
   DO UNTIL QNumb >= rndnumb
     LINE INPUT #1, a$
     IF LTRIM$(RTRIM$(a$)) = "" THEN QNumb = QNumb + 1
   LOOP

 CASE "NewL"
   DO UNTIL QNumb >= rndnumb
     LINE INPUT #1, a$
     QNumb = QNumb + 1
  LOOP
 
  CASE "NewLM"
    counter = 0
    StillBlank = TRUE
    IF NewLMCon = TRUE THEN
      DO UNTIL QNumb >= rndnumb
        LINE INPUT #1, a$
        IF LTRIM$(RTRIM$(a$)) = "" THEN
          IF StillBlank = TRUE THEN
            counter = counter + 1
            IF counter = NewLMNumb THEN
              counter = 0
              QNumb = QNumb + 1
            END IF
          ELSE
            counter = counter + 1
            StillBlank = TRUE
          END IF
        ELSE
          StillBlank = FALSE
          counter = 0
        END IF
      LOOP
    ELSE
      DO UNTIL QNumb >= rndnumb
        LINE INPUT #1, a$
        IF LTRIM$(RTRIM$(a$)) = "" THEN
          counter = counter + 1
          IF counter = NewLMNumb THEN
            counter = 0
            QNumb = QNumb + 1
          END IF
        END IF
      LOOP
   END IF
    
  CASE ELSE
    DO UNTIL QNumb >= rndnumb
      a$ = INPUT$(1, #1)
      IF a$ = Delim(filenumb) THEN QNumb = QNumb + 1
    LOOP
  END SELECT


'put quote in an array
'''ON ERROR GOTO TooManyL   'if the quote is too big for what they want, then leave

SELECT CASE Delim(filenumb)

  CASE "NewL2"
    DO UNTIL EOF(1)
      LineNum = LineNum + 1
      LINE INPUT #1, Lines$(LineNum)
      IF RTRIM$(LTRIM$(Lines$(LineNum))) = "" THEN
        LineNum = LineNum - 1
        EXIT DO
      END IF
    LOOP

  CASE "NewL"
    LineNum = 1
    LINE INPUT #1, Lines$(LineNum)

  CASE "NewLM"
    counter = 0
    StillBlank = TRUE
    IF NewLMCon = TRUE THEN
      DO UNTIL EOF(1)
        LineNum = LineNum + 1
        LINE INPUT #1, Lines$(LineNum)
        IF RTRIM$(LTRIM$(Lines$(LineNum))) = "" THEN
          IF StillBlank = TRUE THEN
            counter = counter + 1
            IF counter = NewLMNumb THEN
              LineNum = LineNum - NewLMNumb
              EXIT DO
            END IF
          ELSE
            counter = counter + 1
            StillBlank = TRUE
          END IF
        ELSE
          StillBlank = FALSE
          counter = 0
        END IF
      LOOP
    ELSE
      DO UNTIL EOF(1)
        LineNum = LineNum + 1
        LINE INPUT #1, Lines$(LineNum)
        IF RTRIM$(LTRIM$(Lines$(LineNum))) = "" THEN
          counter = counter + 1
          IF counter = NewLMNumb THEN
            LineNum = LineNum - 1
            EXIT DO
          END IF
        ELSE
        END IF
      LOOP
   END IF


  CASE ELSE
    DO UNTIL EOF(1)
      LineNum = LineNum + 1
      LINE INPUT #1, Lines$(LineNum)
      QNumb = INSTR(Lines$(LineNum), Delim(filenumb))
      IF QNumb <> 0 THEN
        Lines$(LineNum) = LEFT$(Lines$(LineNum), QNumb - 1)
        EXIT DO
      END IF
    LOOP
  END SELECT
'''ON ERROR GOTO DontKnow


IF CentVert(filenumb) <> 0 THEN
  IF CentVert(filenumb) = TRUE THEN
    CenterVert = TRUE
  ELSE
    CenterVert = FALSE
  END IF
END IF
IF CentHor(filenumb) <> 0 THEN
  IF CentHor(filenumb) = TRUE THEN
    CenterHor = TRUE
  ELSE
    CenterHor = FALSE
  END IF
END IF
b% = 0
IF ClsBefore = TRUE THEN CLS
IF CenterVert = FALSE THEN PRINT ""
IF header(filenumb) = "" THEN Heading = FALSE
IF INSTR(COMMAND$, "WOW") <> 0 THEN
  FOR a = 1 TO 6
  IF LineNum > 23 THEN EXIT FOR
  SELECT CASE a
    CASE 1: CLS : COLOR 8
    CASE 2 OR 6: COLOR 7: waitin (.2)
    CASE 3: COLOR 15: waitin (.2)
    CASE 4: COLOR 7: waitin (LineNum * 4)
    CASE 5: COLOR 8: waitin (.2)
  END SELECT
  LOCATE (13 - (INT((LineNum) / 2)))
  FOR x = 1 TO LineNum
    LOCATE , (40 - (INT((LEN(Lines$(x))) / 2)))
    PRINT SPACE$(LEN(Lines$(x)))
  NEXT x
  IF a = 6 THEN GOTO EndOfPrinting
  LOCATE (13 - (INT((LineNum) / 2)))
  FOR x = 1 TO LineNum
    LOCATE , (40 - (INT((LEN(Lines$(x))) / 2)))
    PRINT Lines$(x)
  NEXT x
  NEXT a
END IF
IF Heading = TRUE THEN MoreLines = 1
IF CenterVert = TRUE THEN
  IF LineNum < 21 THEN
    LOCATE (13 - (INT((LineNum + MoreLines) / 2))), 1 'center quote
  ELSE
    LOCATE (13 - (INT((21 + MoreLines) / 2))), 1 'center quote
  END IF
END IF
IF numbers = TRUE THEN
  LineNum = LineNum + 1
  Lines$(LineNum) = "(" + LTRIM$(STR$(filenumb)) + "," + LTRIM$(STR$(rndnumb)) + ")"
END IF
IF TimeUsed = TRUE THEN
  LineNum = LineNum + 1
  finish! = TIMER
  Lines$(LineNum) = LTRIM$(RTRIM$(STR$(finish! - start!)))
END IF
IF ShowTime = TRUE THEN
  LineNum = LineNum + 1
  CALL subTime(timey$)
  Lines$(LineNum) = timey$
END IF
IF CenterHor = TRUE THEN   'the actual printing is done in this loop
  IF Heading = TRUE THEN        'printing of heading
    LOCATE , (40 - (INT((LEN(header(filenumb))) / 2)))
    PRINT header(filenumb)
  END IF
  DO
    b% = b% + 1
    IF autowrap = TRUE AND LEN(Lines$(b%)) > AutoNumb THEN
      Trim Lines$(b%), AutoNumb, party(), count
      FOR x = 2 TO count
        LOCATE , (40 - (INT((LEN(party(x))) / 2)))
        PRINT party(x)
      NEXT x
    ELSE
      LOCATE , (40 - (INT((LEN(Lines$(b%))) / 2)))
      PRINT Lines$(b%)
    END IF
    liner = liner + 1
    IF liner = 19 AND b% <> LineNum THEN
      GOSUB waiting
      liner = 0
    END IF
  LOOP UNTIL b% = LineNum
ELSE
  IF Heading = TRUE THEN PRINT header(filenumb)
  DO
    b% = b% + 1
    IF autowrap = TRUE AND LEN(Lines$(b%)) > AutoNumb THEN
      Trim Lines$(b%), AutoNumb, party(), count
      FOR x = 2 TO count
        PRINT party(x)
      NEXT x
    ELSE
      PRINT Lines$(b%)
    END IF
    liner = liner + 1
    IF liner = 19 AND b% <> LineNum THEN
      GOSUB waiting
      liner = 0
    END IF
  LOOP UNTIL b% = LineNum
  IF CenterVert = FALSE THEN PRINT ""
END IF

EndOfPrinting:
b% = 0
CLOSE
IF INKEY$ = CHR$(HotKey) THEN
  IF sleepy = 0 THEN NoSleep = TRUE
  GOTO SaveQuote
END IF
  'wait for a time limit that is from number of lines in the quote
IF sleepy <> 0 THEN
  SLEEP (sleepy * LineNum)
  END IF
Ending:
IF INKEY$ = CHR$(HotKey) THEN GOTO SaveQuote

RealEnder:
IF ClsAfter = TRUE THEN
  CLS
ELSE
  LOCATE 23, 1
END IF
CLOSE
END

'**************************************************************************

'other things...

SaveQuote:
OPEN HKeyFile$ FOR APPEND AS #1
DO
  b% = b% + 1
  PRINT #1, Lines$(b%)
LOOP UNTIL b% = LineNum
'a$ = ""
PRINT #1,
b% = 0
IF NoSleep = TRUE THEN
  SLEEP (sleepy * LineNum)
END IF
GOTO RealEnder

waiting:
PRINT
PRINT "Press any key to continue..."
WHILE INKEY$ = "": WEND
WHILE INKEY$ <> "": WEND
IF LEN(a$) <> 0 THEN IF ASC(a$) = 27 THEN GOTO Ending
CLS
IF CenterVert = TRUE THEN
  IF LineNum - b% < 21 THEN
    LOCATE (13 - (INT((LineNum - b% + MoreLines) / 2))), 1'center quote
  ELSE
    LOCATE (13 - (INT((21 + MoreLines) / 2))), 1 'center quote
  END IF
END IF
RETURN

'**************************************************************************

'the following deals with problems that might occur (but hopefuly won't!)

NoIniFile:
CLS
IF NotFir = FALSE THEN
  NotFir = TRUE
  OPEN "c:\sayings\sayings.ini" FOR INPUT AS #1
  RESUME NEXT
ELSE
  PRINT "ERROR:  The program cannot find the sayings.ini file."
  END
END IF
GOTO Main

TooManyL:
Checker = Checker + 1              'just in case in an endless loop
IF Checker > 50 THEN
  PRINT "SAYINGS by Brian Deitte"
  PRINT "Your quote file"; file$
  PRINT "is messed up or your sayings.ini file is."
  PRINT "Fix them! :)"
  CLOSE
  END
END IF
GOTO TheINIConfig

DontKnow:
PRINT "SAYINGS by Brian Deitte"
PRINT "An unknown problem has stopped this program from working."
PRINT "Please refer to sayings.doc for more information."
CLOSE
END

AlteredINI:
PRINT "SAYINGS by Brian Deitte"
PRINT "The sayings.ini file"
PRINT "has been altered so that this program cannot read it."
PRINT "Please refer to sayings.doc for more information."
CLOSE
END

SUB subTime (timey$)
timey$ = TIME$
IF LEFT$(timey$, 1) = "0" THEN
  timey$ = MID$(timey$, 2, 7) + " a.m."
  EXIT SUB
END IF
IF LEFT$(timey$, 2) = "10" OR LEFT$(timey$, 2) = "11" THEN
  timey$ = timey$ + " a.m."
  EXIT SUB
END IF
IF LEFT$(timey$, 2) = "12" THEN
  timey$ = timey$ + " p.m."
  EXIT SUB
ELSE
  hours$ = STR$(VAL(LEFT$(timey$, 2)) - 12)
  timey$ = hours$ + MID$(timey$, 3, 6)
  IF LEFT$(timey$, 2) = "12" THEN
    timey$ = timey$ + " a.m."
  ELSE
    timey$ = timey$ + " p.m."
  END IF
END IF
END SUB

SUB Trim (a$, AutoNumb, part() AS STRING, count)
    parta = 1
    count = 1
    DO
      count = count + 1
      IF LEN(RIGHT$(a$, LEN(a$) - parta)) < AutoNumb THEN
        part(count) = RIGHT$(a$, LEN(RIGHT$(a$, LEN(a$) - parta)) + 1)
        EXIT DO
      END IF
      AutoNumb2 = AutoNumb
      parta2 = parta
      first = 1
      buff = 0
      DO
        space = INSTR(MID$(a$, parta2, AutoNumb2), " ")
        IF space = 0 THEN
          IF first = 1 THEN
            part(count) = MID$(a$, parta, AutoNumb)
            parta = parta + AutoNumb
            EXIT DO
          ELSE
            part(count) = MID$(a$, parta, buff)
            parta = parta + buff
            EXIT DO
          END IF
        END IF
        parta2 = parta2 + space
        AutoNumb2 = AutoNumb2 - space
        first = NOT 1
        buff = buff + space
      LOOP
    LOOP
END SUB

SUB waitin (timey!)
timea! = TIMER
WHILE INKEY$ <> "": WEND
DO: LOOP UNTIL TIMER > timea! + timey! OR INKEY$ <> ""
END SUB

